module sys.cmdline [] {
   constructor: '+'/2.

   count = kernel:cmdline_count.

   {Index} = kernel:cmdline_get(Index).

   list = kernel:cmdline_list.

   parse(M) :-
      IndexRef = data.ref.backtrackable:new(1),
      module SimpleNext [IndexRef] {
         get(Arg) :-
            Index = IndexRef:get,
            (
               data.number:(Index < kernel:cmdline_count)
            ->
               Arg = kernel:cmdline_get(Index),
               IndexRef:set(data.number:succ(Index))
            ;
               fail
            ).
      },
      module [M, IndexRef, SimpleNext] {
         argument_next(Used, FirstArgument) =
            module [SimpleNext, Used, FirstArgument] {
               get(Arg) :-
                  (
                     Used == 'true'
                  ->
                     Arg = SimpleNext:get
                  ;
                     Used = 'true',
                     Arg = FirstArgument:get
                  )
            }.

         do_files :-
            Index = IndexRef:get,
            (
               data.number:(Index < sys.cmdline:count)
            ->
               Arg = sys.cmdline:({Index}),
               IndexRef:set(data.number:succ(Index)),
               (
                  M:file(Arg)
               ->
                  do_files
               ;
                  throw('error'('cmdline'('invalid_file'(Arg))))
               )
            ;
               true
            ). 

         do :-
            Index = IndexRef:get,
            (
               data.number:(Index < sys.cmdline:count)
            ->
               Arg = sys.cmdline:({Index}),
               IndexRef:set(data.number:succ(Index)),
               (
                  Arg = '--'
               ->
                  do_files
               ;
                  data.atom:concat('--', FullLongOption, Arg)
               ->
                  (
                     data.atom:split_at_delim_left(
                        FullLongOption, '=', LongOption, FirstArgument
                     )
                  ->
                     (
                        M:long(
                           LongOption,
                           this:argument_next(Used, module [FirstArgument] {
                              get = FirstArgument
                           })
                        )
                     ->
                        (
                           Used = 'false'
                        ->
                           throw(
                              'error'(
                                 'cmdline'(
                                    'option_without_argument'(
                                       data.atom:concat('--', LongOption)
                                    )
                                 )
                              )
                           )
                        ;
                           this:do
                        )
                     ;
                        throw(
                           'error'(
                              'cmdline'(
                                 'invalid_option'(
                                    data.atom:concat('--', LongOption)
                                 )
                              )
                           )
                        )
                     )
                  ;
                     (
                        M:long(FullLongOption, SimpleNext)
                     ->
                        do
                     ;
                        throw(
                           'error'(
                              'cmdline'(
                                 'invalid_option'(Arg)
                              )
                           )
                        )
                     )
                  )
               ;
                  data.atom:sub(Arg, 0, 1, Count, '-'),
                  data.number:(Count > 0)
               ->
                  Parent = this,
                  module [M, Arg, Count, Parent, SimpleNext] {
                     do(Index) :-
                        (
                           data.number:(Index =< Count)
                        ->
                           Opt = data.atom:sub(Arg, Index, 1, _),
                           (
                              (
                                 data.number:(Index + 1 =< Count)
                              ->
                                 M:short(
                                    Opt,
                                    Parent:argument_next(Used, module [Arg, Index] {
                                       get = data.atom:sub(
                                          Arg,
                                          data.number:(Index + 1), _, 0
                                       )
                                    })
                                 )
                              ;
                                 Used = 'true',
                                 M:short(
                                    Opt,
                                    SimpleNext
                                 )
                              )
                           ->
                              (
                                 Used = 'false'
                              ->
                                 do(data.number:succ(Index))
                              ;
                                 true
                              )
                           ;
                              throw(
                                 'error'(
                                    'cmdline'(
                                       'invalid_option'(
                                          data.atom:concat('-', Opt)
                                       )
                                    )
                                 )
                              )
                           )
                        ;
                           true
                        ).
                  }:do(1),
                  do
               ;
                  (
                     (
                        M:default(Arg)
                     ;
                        M:file(Arg)
                     )
                  ->
                     do
                  ;
                     throw('error'('cmdline'('invalid_file'(Arg))))
                  )
               )
            ;
               true
            ).
      }:do.
}
